<template>
  <div>
    <v-carousel hide-delimiters>
      <v-carousel-item :src="require('../assets/img/home/slider4.jpeg')">
        <v-row
          class="fill-height"
          align="center"
          justify="center"
        >
          <div class="display-2 white--text pl-5 pr-5 hidden-sm-only">
            <strong>Выездная химчистка Баром</strong>
          </div>
          <br/>
        </v-row>
      </v-carousel-item>
      <v-carousel-item :src="require('../assets/img/home/slider2.jpeg')">
        <v-row
          class="fill-height"
          align="center"
          justify="center">
          <div class="display-2 white--text pl-5 pr-5 hidden-sm-only">
            <strong>Выездная химчистка Баром</strong>
          </div>
          <br/>
        </v-row>
      </v-carousel-item>
      <v-carousel-item :src="require('../assets/img/home/slider3.jpeg')">
        <v-row
          class="fill-height"
          align="center"
          justify="center"
        >
          <div class="display-2 white--text pl-5 pr-5 hidden-sm-only">
            <strong>Выездная химчистка Баром</strong>
          </div>
          <br/>
        </v-row>
      </v-carousel-item>
      <v-carousel-item :src="require('../assets/img/home/slider1.jpeg')">
        <v-row
          class="fill-height"
          align="center"
          justify="center"
        >
          <div class="display-2 white--text pl-5 pr-5 hidden-sm-only">
            <strong>Выездная химчистка Баром</strong>
          </div>
          <br/>
        </v-row>
      </v-carousel-item>
    </v-carousel>
    <div class="pl-4 pr-4 row">
      <div class="col-md-6 col-sm-6 col-xs-12">
        <v-card>
          <v-img
            :src="require('../assets/img/home/slider2.jpeg')"
            class="white--text align-center"
            gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
            height="400px"
          >
            <h1 class="text-center font-size">Посты</h1>
            <div class="text-center">
              <v-btn  href="/blog" class="white--text " outlined>Перейти</v-btn>
            </div>
          </v-img>
        </v-card>
      </div>
      <div class="col-md-6 col-sm-6 col-xs-12">
        <v-card>
          <v-img
            :src="require('../assets/img/home/slider3.jpeg')"
            class="white--text align-center"
            gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
            height="400px"
          >
            <h1 class="text-center font-size">Наши услуги</h1>
            <div class="text-center">
              <v-btn
                href="/services"
                class="white--text"
                outlined
              >
                Перейти
              </v-btn>
            </div>
          </v-img>
        </v-card>
      </div>
    </div>
    <div class="pl-4 pr-4 row">
      <div class="col-md-4 col-sm-4 col-xs-12">
        <v-card outlined>
          <v-img
            :src="require('../assets/img/home/deal1.jpeg')"
            class="white--text align-center"
            gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
            height="300px"
          >
            <h1 class="text-center font-size"></h1>
            <div class="text-center mt-2">
              <v-btn
                class="white--text caption"
                href="/#"
                text
              >
                ЗАКАЗАТь
                <v-icon class="white--text caption">
                  mdi-arrow-right
                </v-icon>
              </v-btn>
            </div>
          </v-img>
        </v-card>
      </div>
      <div class="col-md-4 col-sm-4 col-xs-12">
        <v-card outlined>
          <v-img
            :src="require('../assets/img/home/deal3.jpeg')"
            class="white--text align-center"
            gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
            height="300px"
          >
            <h1 class="text-center font-size"></h1>
            <div class="text-center mt-2">
              <v-btn
                class="white--text caption"
                href="/#"
                text
              >
                ЗАКАЗАТь
                <v-icon class="white--text caption">
                  mdi-arrow-right
                </v-icon>
              </v-btn>
            </div>
          </v-img>
        </v-card>
      </div>
      <div class="col-md-4 col-sm-4 col-xs-12">
        <v-card outlined>
          <v-img
            :src="require('../assets/img/home/deal4.jpeg')"
            class="white--text align-center"
            gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
            height="300px"
          >
            <h1 class="text-center font-size"></h1>
            <div class="text-center mt-2">
              <v-btn
                class="white--text caption"
                href="/#"
                text
              >
                ЗАКАЗАТь
                <v-icon class="white--text caption">
                  mdi-arrow-right
                </v-icon>
              </v-btn>
            </div>
          </v-img>
        </v-card>
      </div>
    </div>
    <v-container>
      <v-row no-gutters>
        <v-col :cols="12">
          <v-card-text
            class=""
            tile
            outlined
          >
            <v-card-title class="subheading ">Популярные посты</v-card-title>
            <v-divider></v-divider>
            <div class="row">
              <div
                v-for="post in listPosts"
                :key='post.id'
                class="col-12 col-md-3 col-sm-6 col-xs-6 text-center"
              >
                <v-hover
                  v-slot:default="{ hover }"
                  open-delay="200"
                >
                  <v-card :elevation="hover ? 16 : 2">
                    <v-img
                      class="white--text align-end"
                      height="200px"
                      :src="post.photo"
                    >
                      <v-card-title>{{ post.title }}</v-card-title>
                    </v-img>
                    <v-card-text class="text--primary text-center">
                      <div>
                        {{ post.likes }}
                        <v-icon>
                          mdi-cards-heart
                        </v-icon>
                      </div>
                    </v-card-text>
                    <div class="text-center">
                      <v-btn
                        @click="goTo(post.id)"
                        class="ma-2"
                        outlined
                        color="info"
                      >
                        Подробнее
                      </v-btn>
                    </div>
                  </v-card>
                </v-hover>
              </div>
            </div>
          </v-card-text>
        </v-col>
      </v-row>
    </v-container>
    <v-container>
      <v-card-title class="subheading ">Подписаться на рассылку</v-card-title>
      <v-divider/>
      <v-form
        @submit.prevent="emailSendingHandler"
        ref="form"
        v-model="valid"
        lazy-validation
      >
        <v-row>
          <v-text-field
            v-model="email"
            :rules="emailRules"
            label="Введите свой email"
            required
          />
        </v-row>
        <v-row>
          <v-btn
            :disabled="!valid"
            :type="'submit'"
            color="blue"
            class="mr-4"
            @click="check"
          >
            Подписаться
          </v-btn>
        </v-row>
        <v-snackbar
          v-model="snackbar"
          timeout=3000
          content-class="text-center"
        >
          {{ text }}
        </v-snackbar>
      </v-form>
    </v-container>
  </div>
</template>

<script>
import axios from "axios"

export default {
  name: 'Home',
  data() {
    return {
      listPosts: [],
      email: '',
      emailRules: [
        v => !!v || 'E-mail is required',
        v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
      ],
      snackbar: false,
      text: 'Вы подписались на нашу рассылку',
      error: false,
    }
  },
  computed: {
    check() {
      return this.error ? this.snackbar = true : this.snackbar = false
    }
  },
  created() {
    this.$setTitle('Домашняя страница')
    this.loadListPost()
  },
  methods: {
    async loadListPost() {
      this.$store.commit('setLoading', true)
      this.listPosts = await fetch(
        `${this.$store.getters.getServerUrl}api/v1/posts/popular`
      ).then(response => response.json())
      this.$store.commit('setLoading', false)
    },
    goTo(id) {
      this.$router.push({ name: 'Post', params:{ id: id } })
    },
    async emailSendingHandler() {
      await axios({
        method: 'POST',
        data: { 'email': this.email },
        url: `${this.$store.getters.getServerUrl}api/v1/celery/subscribe/`
      })
      .then(resp => {
        console.log(resp.data)
        this.snackbar = true
      })
      .catch(error => {
        console.log(error)
        console.log('Не удалось подписаться на рассылку')
      })
    }
  }
}
</script>
<style>
.v-card--reveal {
  align-items: center;
  bottom: 0;
  justify-content: center;
  opacity: .5;
  position: absolute;
  width: 100%;
}
</style>

